<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfIdentifierVehicleGeoFenceResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfIdentifierVehicleGeoFenceResult extends AbstractStructArrayBase
{
    /**
     * The IdentifierVehicleGeoFenceResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IdentifierVehicleGeoFenceResult[]
     */
    public $IdentifierVehicleGeoFenceResult;
    /**
     * Constructor method for ArrayOfIdentifierVehicleGeoFenceResult
     * @uses ArrayOfIdentifierVehicleGeoFenceResult::setIdentifierVehicleGeoFenceResult()
     * @param \StructType\IdentifierVehicleGeoFenceResult[] $identifierVehicleGeoFenceResult
     */
    public function __construct(array $identifierVehicleGeoFenceResult = array())
    {
        $this
            ->setIdentifierVehicleGeoFenceResult($identifierVehicleGeoFenceResult);
    }
    /**
     * Get IdentifierVehicleGeoFenceResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IdentifierVehicleGeoFenceResult[]|null
     */
    public function getIdentifierVehicleGeoFenceResult()
    {
        return isset($this->IdentifierVehicleGeoFenceResult) ? $this->IdentifierVehicleGeoFenceResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setIdentifierVehicleGeoFenceResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setIdentifierVehicleGeoFenceResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateIdentifierVehicleGeoFenceResultForArrayConstraintsFromSetIdentifierVehicleGeoFenceResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfIdentifierVehicleGeoFenceResultIdentifierVehicleGeoFenceResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfIdentifierVehicleGeoFenceResultIdentifierVehicleGeoFenceResultItem instanceof \StructType\IdentifierVehicleGeoFenceResult) {
                $invalidValues[] = is_object($arrayOfIdentifierVehicleGeoFenceResultIdentifierVehicleGeoFenceResultItem) ? get_class($arrayOfIdentifierVehicleGeoFenceResultIdentifierVehicleGeoFenceResultItem) : sprintf('%s(%s)', gettype($arrayOfIdentifierVehicleGeoFenceResultIdentifierVehicleGeoFenceResultItem), var_export($arrayOfIdentifierVehicleGeoFenceResultIdentifierVehicleGeoFenceResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The IdentifierVehicleGeoFenceResult property can only contain items of type \StructType\IdentifierVehicleGeoFenceResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set IdentifierVehicleGeoFenceResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierVehicleGeoFenceResult[] $identifierVehicleGeoFenceResult
     * @return \ArrayType\ArrayOfIdentifierVehicleGeoFenceResult
     */
    public function setIdentifierVehicleGeoFenceResult(array $identifierVehicleGeoFenceResult = array())
    {
        // validation for constraint: array
        if ('' !== ($identifierVehicleGeoFenceResultArrayErrorMessage = self::validateIdentifierVehicleGeoFenceResultForArrayConstraintsFromSetIdentifierVehicleGeoFenceResult($identifierVehicleGeoFenceResult))) {
            throw new \InvalidArgumentException($identifierVehicleGeoFenceResultArrayErrorMessage, __LINE__);
        }
        if (is_null($identifierVehicleGeoFenceResult) || (is_array($identifierVehicleGeoFenceResult) && empty($identifierVehicleGeoFenceResult))) {
            unset($this->IdentifierVehicleGeoFenceResult);
        } else {
            $this->IdentifierVehicleGeoFenceResult = $identifierVehicleGeoFenceResult;
        }
        return $this;
    }
    /**
     * Add item to IdentifierVehicleGeoFenceResult value
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierVehicleGeoFenceResult $item
     * @return \ArrayType\ArrayOfIdentifierVehicleGeoFenceResult
     */
    public function addToIdentifierVehicleGeoFenceResult(\StructType\IdentifierVehicleGeoFenceResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\IdentifierVehicleGeoFenceResult) {
            throw new \InvalidArgumentException(sprintf('The IdentifierVehicleGeoFenceResult property can only contain items of type \StructType\IdentifierVehicleGeoFenceResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->IdentifierVehicleGeoFenceResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\IdentifierVehicleGeoFenceResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\IdentifierVehicleGeoFenceResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\IdentifierVehicleGeoFenceResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\IdentifierVehicleGeoFenceResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\IdentifierVehicleGeoFenceResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string IdentifierVehicleGeoFenceResult
     */
    public function getAttributeName()
    {
        return 'IdentifierVehicleGeoFenceResult';
    }
}
